	.module discover.c
	.area data(ram, con, rel)
_version:
	.blkw 1
	.area idata
	.word L2
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
	.dbsym s version _version pc
	.area text(rom, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
	.dbfunc e InitializeConsole _InitializeConsole fI
;           baud -> y+2
	.even
_InitializeConsole::
	xcall push_gset2
	sbiw R28,6
	.dbline -1
	.dbline 101
; /*
;  * Copyright (C) 2004 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  */
; 
; /*
;  * $Log$
;  */
; 
; #include <dev/debug.h>
; #ifdef ETHERNUT2
; #include <dev/lanc111.h>
; #else
; #include <dev/nicrtl.h>
; #endif
; #include <sys/thread.h>
; #include <sys/timer.h>
; #include <sys/version.h>
; #include <sys/confnet.h>
; #include <sys/confos.h>
; 
; #include <sys/confnet.h>
; #include <sys/socket.h>
; #include <arpa/inet.h>
; 
; #include <netinet/in.h>
; #include <pro/dhcp.h>
; 
; #include <stdlib.h>
; #include <string.h>
; #include <stdio.h>
; #include <fcntl.h>
; #include <io.h>
; 
; #include "discover.h"
; 
; static char *version = "1.0.1";
; 
; /*
;  * Device used for stdout. 
;  */
; #define STDOUT_DEV      devDebug0
; 
; /*
;  * Symbolic name of the stdout device.
;  */
; #define STDOUT_DEVNAME  "uart0"
; 
; /*
;  * Bitrate of the stdout device.
;  */
; #define STDOUT_BAUDRATE 115200
; 
; /*
;  * Default MAC address.
;  *
;  * Used if none has been found in EEPROM.
;  */
; #define STDNET_MAC      { 0x00, 0x06, 0x98, 0x20, 0x00, 0x00 }
; 
; /*
;  * Default IP address and network mask.
;  *
;  * Used if not found in EEPROM and if no DHCP response received.
;  */
; #define STDNET_IPADDR   "192.168.192.202"
; #define STDNET_IPMASK   "255.255.255.0"
; 
; 
; /*
;  * Open a standard output device.
;  */
; int InitializeConsole(void)
; {
	.dbline 102
;     u_long baud = 115200;
	ldi R20,0
	ldi R21,194
	ldi R22,1
	ldi R23,0
	movw R30,R28
	std z+2,R20
	std z+3,R21
	std z+4,R22
	std z+5,R23
	.dbline 104
; 
;     if(NutRegisterDevice(&devDebug0, 0, 0)) {
	clr R2
	std y+0,R2
	clr R18
	clr R19
	ldi R16,<_devDebug0
	ldi R17,>_devDebug0
	xcall _NutRegisterDevice
	cpi R16,0
	cpc R16,R17
	breq L4
X0:
	.dbline 104
	.dbline 105
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L3
L4:
	.dbline 108
;     }
; 
;     if(freopen("uart0", "w", stdout) == 0) {
	lds R2,___iob+2
	lds R3,___iob+2+1
	std y+1,R3
	std y+0,R2
	ldi R18,<L9
	ldi R19,>L9
	ldi R16,<L8
	ldi R17,>L8
	xcall _freopen
	cpi R16,0
	cpc R16,R17
	brne L6
X1:
	.dbline 108
	.dbline 109
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L3
L6:
	.dbline 111
;     }
;     return _ioctl(_fileno(stdout), UART_SETSPEED, &baud);
	lds R16,___iob+2
	lds R17,___iob+2+1
	xcall __fileno
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,257
	ldi R19,1
	xcall __ioctl
	.dbline -2
L3:
	adiw R28,6
	xcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbsym l baud 2 l
	.dbend
	.area lit(rom, con, rel)
L13:
	.byte 0,6
	.byte 152,32
	.byte 0,0
	.area text(rom, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
	.dbfunc e InitializeNetwork _InitializeNetwork fI
;        ip_mask -> y+18
;        ip_addr -> y+14
;       null_mac -> y+8
;             rc -> R10,R11
	.even
_InitializeNetwork::
	xcall push_gset3
	sbiw R28,22
	.dbline -1
	.dbline 118
; }
; 
; /*
;  * Open a network device.
;  */
; int InitializeNetwork(void)
; {
	.dbline 119
;     u_char null_mac[] = STDNET_MAC;
	ldi R24,<L13
	ldi R25,>L13
	movw R30,R28
	adiw R30,8
	ldi R16,6
	ldi R17,0
	st -y,R31
	st -y,R30
	st -y,R25
	st -y,R24
	xcall asgncblk
	.dbline 122
;     int rc;
; 
;     rc = NutRegisterDevice(&DEV_ETHER, 0x8300, 5);
	ldi R24,5
	std y+0,R24
	ldi R18,33536
	ldi R19,131
	ldi R16,<_devSmsc111
	ldi R17,>_devSmsc111
	xcall _NutRegisterDevice
	movw R10,R16
	.dbline 124
; 
;     if(rc == 0) {
	cpi R16,0
	cpc R16,R17
	breq X5
	xjmp L14
X5:
X2:
	.dbline 124
	.dbline 126
;         /* Try DHCP with MAC from EEPROM. */
;         rc = NutDhcpIfConfig("eth0", 0, 60000);
	ldi R20,96
	ldi R21,234
	ldi R22,0
	ldi R23,0
	std y+0,R20
	std y+1,R21
	std y+2,R22
	std y+3,R23
	clr R18
	clr R19
	ldi R16,<L16
	ldi R17,>L16
	xcall _NutDhcpIfConfig
	movw R10,R16
	.dbline 127
;         if (rc) {
	cpi R16,0
	cpc R16,R17
	brne X6
	xjmp L17
X6:
X3:
	.dbline 127
	.dbline 129
;             /* No valid EEPROM contents, use hard coded MAC. */
;             rc = NutDhcpIfConfig("eth0", null_mac, 60000);
	ldi R20,96
	ldi R21,234
	ldi R22,0
	ldi R23,0
	std y+0,R20
	std y+1,R21
	std y+2,R22
	std y+3,R23
	movw R18,R28
	subi R18,248  ; offset = 8
	sbci R19,255
	ldi R16,<L16
	ldi R17,>L16
	xcall _NutDhcpIfConfig
	movw R10,R16
	.dbline 130
;             if (rc) {
	cpi R16,0
	cpc R16,R17
	brne X7
	xjmp L19
X7:
X4:
	.dbline 130
	.dbline 132
;                 /* No DHCP server found, use hard coded IP. */
;                 u_long ip_addr = inet_addr(STDNET_IPADDR);
	ldi R16,<L21
	ldi R17,>L21
	xcall _inet_addr
	movw R30,R28
	std z+14,R16
	std z+15,R17
	std z+16,R18
	std z+17,R19
	.dbline 133
;                 u_long ip_mask = inet_addr(STDNET_IPMASK);
	ldi R16,<L22
	ldi R17,>L22
	xcall _inet_addr
	movw R30,R28
	std z+18,R16
	std z+19,R17
	std z+20,R18
	std z+21,R19
	.dbline 135
; 
;                 rc = NutNetIfConfig("eth0", null_mac, ip_addr, ip_mask);
	movw R30,R28
	ldd R2,z+18
	ldd R3,z+19
	ldd R4,z+20
	ldd R5,z+21
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	movw R30,R28
	ldd R2,z+14
	ldd R3,z+15
	ldd R4,z+16
	ldd R5,z+17
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	movw R18,R28
	subi R18,248  ; offset = 8
	sbci R19,255
	ldi R16,<L16
	ldi R17,>L16
	xcall _NutNetIfConfig
	movw R10,R16
	.dbline 136
;             }
L19:
	.dbline 137
;         }
L17:
	.dbline 138
;     }
L14:
	.dbline 139
;     return rc;
	movw R16,R10
	.dbline -2
L12:
	adiw R28,22
	xcall pop_gset3
	.dbline 0 ; func end
	ret
	.dbsym l ip_mask 18 l
	.dbsym l ip_addr 14 l
	.dbsym l null_mac 8 A[6:6]c
	.dbsym r rc 10 I
	.dbend
	.dbfunc e Announce _Announce fV
	.dbstruct 0 4 _NBDATA
	.dbfield 0 vp pV
	.dbfield 2 sz s
	.dbend
	.dbstruct 0 19 _NETBUF
	.dbfield 0 nb_next pS[_NETBUF]
	.dbfield 2 nb_flags c
	.dbfield 3 nb_dl S[_NBDATA]
	.dbfield 7 nb_nw S[_NBDATA]
	.dbfield 11 nb_tp S[_NBDATA]
	.dbfield 15 nb_ap S[_NBDATA]
	.dbend
	.dbstruct 0 12 udp_socket
	.dbfield 0 so_next pS[udp_socket]
	.dbfield 2 so_local_port s
	.dbfield 4 so_rx_nb pS[_NETBUF]
	.dbfield 6 so_rx_rdy pV
	.dbfield 8 so_rx_cnt s
	.dbfield 10 so_rx_bsz s
	.dbend
	.dbstruct 0 43 .1
	.dbfield 0 tele_type c
	.dbfield 1 tele_xid l
	.dbfield 5 tele_hostname A[16:16]c
	.dbfield 21 tele_mac A[6:6]c
	.dbfield 27 tele_ip_addr l
	.dbfield 31 tele_ip_mask l
	.dbfield 35 tele_gateway l
	.dbfield 39 tele_cip_addr l
	.dbend
;           tele -> R12,R13
;            xid -> y+16
;           sock -> R10,R11
	.even
_Announce::
	st -y,r19
	st -y,r18
	xcall push_gset4
	movw R10,R16
	sbiw R28,8
	ldd R12,y+20
	ldd R13,y+21
	.dbline -1
	.dbline 146
; }
; 
; /*
;  * Broadcast an announcement datagram.
;  */
; void Announce(UDPSOCKET * sock, u_long xid, DISCOVER *tele)
; {
	.dbline 147
;     memset(tele, 0, sizeof(DISCOVER));
	ldi R24,43
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	movw R16,R12
	xcall _memset
	.dbline 149
; 
;     tele->tele_type = 1;
	ldi R24,1
	movw R30,R12
	std z+0,R24
	.dbline 150
;     tele->tele_xid = xid;
	movw R30,R28
	ldd R2,z+16
	ldd R3,z+17
	ldd R4,z+18
	ldd R5,z+19
	movw R30,R12
	std z+1,R2
	std z+2,R3
	std z+3,R4
	std z+4,R5
	.dbline 151
;     memcpy(tele->tele_hostname, confos.hostname, sizeof(tele->tele_hostname) - 1);
	ldi R24,15
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_confos+3
	ldi R19,>_confos+3
	movw R16,R12
	subi R16,251  ; offset = 5
	sbci R17,255
	xcall _memcpy
	.dbline 152
;     memcpy(tele->tele_mac, confnet.cdn_mac, sizeof(tele->tele_mac));
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_confnet+10
	ldi R19,>_confnet+10
	movw R16,R12
	subi R16,235  ; offset = 21
	sbci R17,255
	xcall _memcpy
	.dbline 153
;     tele->tele_ip_addr = confnet.cdn_ip_addr;
	lds R4,_confnet+16+2
	lds R5,_confnet+16+2+1
	lds R2,_confnet+16
	lds R3,_confnet+16+1
	movw R30,R12
	std z+27,R2
	std z+28,R3
	std z+29,R4
	std z+30,R5
	.dbline 154
;     tele->tele_ip_mask = confnet.cdn_ip_mask;
	lds R4,_confnet+20+2
	lds R5,_confnet+20+2+1
	lds R2,_confnet+20
	lds R3,_confnet+20+1
	movw R30,R12
	std z+31,R2
	std z+32,R3
	std z+33,R4
	std z+34,R5
	.dbline 155
;     tele->tele_gateway = confnet.cdn_gateway;
	lds R4,_confnet+24+2
	lds R5,_confnet+24+2+1
	lds R2,_confnet+24
	lds R3,_confnet+24+1
	movw R30,R12
	std z+35,R2
	std z+36,R3
	std z+37,R4
	std z+38,R5
	.dbline 156
;     tele->tele_cip_addr = confnet.cdn_cip_addr;
	lds R4,_confnet+28+2
	lds R5,_confnet+28+2+1
	lds R2,_confnet+28
	lds R3,_confnet+28+1
	movw R30,R12
	std z+39,R2
	std z+40,R3
	std z+41,R4
	std z+42,R5
	.dbline 158
; 
;     NutUdpSendTo(sock, INADDR_BROADCAST, DISCOVER_PORT, tele, sizeof(DISCOVER));
	ldi R24,43
	ldi R25,0
	std y+7,R25
	std y+6,R24
	std y+5,R13
	std y+4,R12
	ldi R24,10999
	ldi R25,42
	std y+3,R25
	std y+2,R24
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,255
	std y+0,R22
	std y+1,R23
	movw R18,R20
	movw R16,R10
	xcall _NutUdpSendTo
	.dbline -2
	.dbline 159
; }
L23:
	adiw R28,8
	xcall pop_gset4
	adiw R28,2
	.dbline 0 ; func end
	ret
	.dbsym r tele 12 pS[.1]
	.dbsym l xid 16 l
	.dbsym r sock 10 pS[udp_socket]
	.dbend
	.dbfunc e DiscoverServer _DiscoverServer fV
;          rport -> y+18
;          raddr -> y+14
;           sock -> R12,R13
;           tele -> R14,R15
;            xid -> y+10
;            num -> R10,R11
;            arg -> R10,R11
	.even
_DiscoverServer::
	xcall push_gset5
	movw R10,R16
	sbiw R28,24
	.dbline -1
	.dbline 165
; 
; /*
;  * Discover service thread.
;  */
; THREAD(DiscoverServer, arg)
; {
	.dbline 174
;     UDPSOCKET *sock;
;     DISCOVER *tele;
;     u_long raddr;
;     u_short rport;
;     int num;
;     u_long xid;
; 
;     /* Create a hopefully unique identifier. */
;     xid = NutGetTickCount();
	xcall _NutGetTickCount
	movw R30,R28
	std z+10,R16
	std z+11,R17
	std z+12,R18
	std z+13,R19
	.dbline 175
	ldi R24,6
	ldi R25,0
	movw R10,R24
	xjmp L34
L31:
	.dbline 175
	.dbline 176
	ldi R24,<_confnet+10
	ldi R25,>_confnet+10
	movw R30,R10
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	clr R3
	clr R4
	clr R5
	movw R30,R28
	ldd R6,z+10
	ldd R7,z+11
	ldd R8,z+12
	ldd R9,z+13
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	movw R30,R28
	std z+10,R6
	std z+11,R7
	std z+12,R8
	std z+13,R9
	.dbline 177
L32:
	.dbline 175
	ldi R24,4
	ldi R25,0
	movw R30,R28
	ldd R2,z+10
	ldd R3,z+11
	ldd R4,z+12
	ldd R5,z+13
	st -y,R24
	movw R16,R2
	movw R18,R4
	xcall lsl32
	movw R30,R28
	std z+10,R16
	std z+11,R17
	std z+12,R18
	std z+13,R19
L34:
	.dbline 175
;     for(num = sizeof(confnet.cdn_mac); --num; xid <<= 4) {
	movw R24,R10
	sbiw R24,1
	movw R10,R24
	tst R10
	breq X11
	xjmp L31
X11:
	tst R11
	breq X12
	xjmp L31
X12:
X8:
	.dbline 180
;         xid += confnet.cdn_mac[num];
;     }
; 
;     /* Send an initial announce telegram. */
;     sock = NutUdpCreateSocket(DISCOVER_PORT);
	ldi R16,10999
	ldi R17,42
	xcall _NutUdpCreateSocket
	movw R12,R16
	.dbline 181
;     tele = malloc(sizeof(DISCOVER));
	ldi R16,43
	ldi R17,0
	xcall _malloc_M
	movw R14,R16
	.dbline 182
;     Announce(sock, xid, tele);
	std y+3,R15
	std y+2,R14
	movw R30,R28
	ldd R2,z+10
	ldd R3,z+11
	ldd R4,z+12
	ldd R5,z+13
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R12
	xcall _Announce
	.dbline 187
L37:
	.dbline 187
; 
;     /* 
;      * Endlessly loop for incoming discover telegrams. 
;      */
;     for (;;) {
	.dbline 188
;         num = NutUdpReceiveFrom(sock, &raddr, &rport, tele, sizeof(DISCOVER), DISCOVER_RATE);
	ldi R20,96
	ldi R21,234
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
	ldi R24,43
	ldi R25,0
	std y+5,R25
	std y+4,R24
	std y+3,R15
	std y+2,R14
	movw R24,R28
	adiw R24,18
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,242  ; offset = 14
	sbci R19,255
	movw R16,R12
	xcall _NutUdpReceiveFrom
	movw R10,R16
	.dbline 189
;         if (num == 0) {
	cpi R16,0
	cpc R16,R17
	brne L41
X9:
	.dbline 189
	.dbline 191
;             /* Timeout, send an announcement. */
;             Announce(sock, xid, tele);
	std y+3,R15
	std y+2,R14
	movw R30,R28
	ldd R2,z+10
	ldd R3,z+11
	ldd R4,z+12
	ldd R5,z+13
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R12
	xcall _Announce
	.dbline 192
;         }
	xjmp L42
L41:
	.dbline 193
;         else if (num == sizeof(DISCOVER)) {
	movw R24,R10
	cpi R24,43
	ldi R30,0
	cpc R25,R30
	breq X13
	xjmp L43
X13:
	.dbline 193
	.dbline 195
;             /* Telegram type 0, request from host. */
;             if (tele->tele_type == 0) {
	movw R30,R14
	ldd R2,z+0
	tst R2
	breq X14
	xjmp L45
X14:
	.dbline 195
	.dbline 196
;                 Announce(sock, ++xid, tele);
	std y+3,R15
	std y+2,R14
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R28
	ldd R2,z+10
	ldd R3,z+11
	ldd R4,z+12
	ldd R5,z+13
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	movw R30,R28
	std z+20,R2
	std z+21,R3
	std z+22,R4
	std z+23,R5
	movw R30,R28
	ldd R2,z+20
	ldd R3,z+21
	ldd R4,z+22
	ldd R5,z+23
	movw R30,R28
	std z+10,R2
	std z+11,R3
	std z+12,R4
	std z+13,R5
	movw R30,R28
	ldd R2,z+20
	ldd R3,z+21
	ldd R4,z+22
	ldd R5,z+23
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R12
	xcall _Announce
	.dbline 197
;             }
	xjmp L46
L45:
	.dbline 199
;             /* Telegram type 2, update from host. ID must match. */
;             else if (tele->tele_type == 2 && tele->tele_xid == xid) {
	movw R30,R14
	ldd R24,z+0
	cpi R24,2
	breq X15
	xjmp L47
X15:
	movw R30,R28
	ldd R2,z+10
	ldd R3,z+11
	ldd R4,z+12
	ldd R5,z+13
	movw R30,R14
	ldd R6,z+1
	ldd R7,z+2
	ldd R8,z+3
	ldd R9,z+4
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	breq X16
	xjmp L47
X16:
	.dbline 199
	.dbline 201
;                 /* Save updated host name. */   
;                 memcpy(confos.hostname, tele->tele_hostname, sizeof(confos.hostname) - 1);
	ldi R24,15
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R14
	subi R18,251  ; offset = 5
	sbci R19,255
	ldi R16,<_confos+3
	ldi R17,>_confos+3
	xcall _memcpy
	.dbline 202
;                 NutSaveConfig();
	xcall _NutSaveConfig
	.dbline 205
; 
;                 /* Save updated network configuration. */
;                 memcpy(confnet.cdn_mac, tele->tele_mac, sizeof(confnet.cdn_mac));
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R14
	subi R18,235  ; offset = 21
	sbci R19,255
	ldi R16,<_confnet+10
	ldi R17,>_confnet+10
	xcall _memcpy
	.dbline 206
;                 confnet.cdn_ip_addr = tele->tele_ip_addr;
	movw R30,R14
	ldd R2,z+27
	ldd R3,z+28
	ldd R4,z+29
	ldd R5,z+30
	sts _confnet+16+1,R3
	sts _confnet+16,R2
	sts _confnet+16+2+1,R5
	sts _confnet+16+2,R4
	.dbline 207
;                 confnet.cdn_ip_mask = tele->tele_ip_mask;
	movw R30,R14
	ldd R2,z+31
	ldd R3,z+32
	ldd R4,z+33
	ldd R5,z+34
	sts _confnet+20+1,R3
	sts _confnet+20,R2
	sts _confnet+20+2+1,R5
	sts _confnet+20+2,R4
	.dbline 208
;                 confnet.cdn_gateway = tele->tele_gateway;
	movw R30,R14
	ldd R2,z+35
	ldd R3,z+36
	ldd R4,z+37
	ldd R5,z+38
	sts _confnet+24+1,R3
	sts _confnet+24,R2
	sts _confnet+24+2+1,R5
	sts _confnet+24+2,R4
	.dbline 209
;                 confnet.cdn_cip_addr = tele->tele_cip_addr;
	movw R30,R14
	ldd R2,z+39
	ldd R3,z+40
	ldd R4,z+41
	ldd R5,z+42
	sts _confnet+28+1,R3
	sts _confnet+28,R2
	sts _confnet+28+2+1,R5
	sts _confnet+28+2,R4
	.dbline 210
;                 NutNetSaveConfig();
	xcall _NutNetSaveConfig
	.dbline 213
; 
;                 /* Send announcement with new data. */
;                 Announce(sock, ++xid, tele);
	std y+3,R15
	std y+2,R14
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R28
	ldd R2,z+10
	ldd R3,z+11
	ldd R4,z+12
	ldd R5,z+13
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	movw R30,R28
	std z+20,R2
	std z+21,R3
	std z+22,R4
	std z+23,R5
	movw R30,R28
	ldd R2,z+20
	ldd R3,z+21
	ldd R4,z+22
	ldd R5,z+23
	movw R30,R28
	std z+10,R2
	std z+11,R3
	std z+12,R4
	std z+13,R5
	movw R30,R28
	ldd R2,z+20
	ldd R3,z+21
	ldd R4,z+22
	ldd R5,z+23
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R12
	xcall _Announce
	.dbline 214
;             }
L47:
L46:
	.dbline 215
;         }
L43:
L42:
	.dbline 218
	ldi R16,208
	ldi R17,7
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
	.dbline 219
	.dbline 187
	.dbline 187
	xjmp L37
X10:
	.dbline -2
L30:
	adiw R28,24
	xcall pop_gset5
	.dbline 0 ; func end
	ret
	.dbsym l rport 18 s
	.dbsym l raddr 14 l
	.dbsym r sock 12 pS[udp_socket]
	.dbsym r tele 14 pS[.1]
	.dbsym l xid 10 l
	.dbsym r num 10 I
	.dbsym r arg 10 pV
	.dbend
	.dbfunc e main _main fI
;        err_net -> R12,R13
;        err_con -> R10,R11
	.even
_main::
	sbiw R28,4
	.dbline -1
	.dbline 226
; 
;         /* Avoid responding to crazy hosts too often. */
;         NutSleep(2000);
;     }
; }
; 
; /*
;  * Main application routine. 
;  */
; int main(void)
; {
	.dbline 234
;     int err_con; /* 0, if console interface OK. */
;     int err_net; /* 0, if network interface OK. */
; 
;     /*
;      * Initialize standard output interface.
;      * If successfull, display some information.
;      */
;     err_con = InitializeConsole();
	xcall _InitializeConsole
	movw R10,R16
	.dbline 235
;     if(err_con == 0) {
	cpi R16,0
	cpc R16,R17
	brne L58
X17:
	.dbline 235
	.dbline 236
;         printf("\n\nDiscovery Service Version %s\n", version);
	lds R18,_version
	lds R19,_version+1
	ldi R16,<L60
	ldi R17,>L60
	xcall _printf_M
	.dbline 237
;         printf("Nut/OS %s\n", NutVersionString());
	xcall _NutVersionString
	movw R18,R16
	ldi R16,<L61
	ldi R17,>L61
	xcall _printf_M
	.dbline 238
;         printf("Compiled by ");
	ldi R16,<L62
	ldi R17,>L62
	xcall _printf_M
	.dbline 240
; #ifdef __IMAGECRAFT__
;         printf("ICCAVR");
	ldi R16,<L63
	ldi R17,>L63
	xcall _printf_M
	.dbline 244
; #else
;         printf("GCC");
; #endif
;         printf(" for ");
	ldi R16,<L64
	ldi R17,>L64
	xcall _printf_M
	.dbline 246
; #ifdef __AVR_ATmega128__
;         puts("ATmega128");
	ldi R16,<L65
	ldi R17,>L65
	xcall _puts_M
	.dbline 250
; #else
;         puts("ATmega103");
; #endif
;     }
L58:
	.dbline 255
; 
;     /*
;      * Initialize network interface.
;      */
;     err_net = InitializeNetwork();
	xcall _InitializeNetwork
	movw R12,R16
	.dbline 256
;     if(err_con == 0) {
	tst R10
	brne L66
	tst R11
	brne L66
X18:
	.dbline 256
	.dbline 257
;         if(err_net) {
	tst R12
	brne X19
	tst R13
	breq L68
X19:
	.dbline 257
	.dbline 258
;             puts("Error: No network");
	ldi R16,<L70
	ldi R17,>L70
	xcall _puts_M
	.dbline 259
	xjmp L69
L68:
	.dbline 259
;         } else {
	.dbline 260
;             printf("Listening at %s:%u\n", inet_ntoa(confnet.cdn_ip_addr), DISCOVER_PORT);
	lds R18,_confnet+16+2
	lds R19,_confnet+16+2+1
	lds R16,_confnet+16
	lds R17,_confnet+16+1
	xcall _inet_ntoa
	ldi R24,10999
	ldi R25,42
	std y+1,R25
	std y+0,R24
	movw R18,R16
	ldi R16,<L71
	ldi R17,>L71
	xcall _printf_M
	.dbline 261
;         }
L69:
	.dbline 262
;     }
L66:
	.dbline 267
; 
;     /*
;      * Start discover server.
;      */
;     if(err_net == 0) {
	tst R12
	brne L73
	tst R13
	brne L73
X20:
	.dbline 267
	.dbline 268
;         NutThreadCreate("discd", DiscoverServer, 0, 768);
	ldi R24,768
	ldi R25,3
	std y+3,R25
	std y+2,R24
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<PL_DiscoverServer
	ldi R19,>PL_DiscoverServer
	ldi R16,<L75
	ldi R17,>L75
	xcall _NutThreadCreate
	.dbline 269
;     }
L73:
	.dbline 274
L76:
	.dbline 274
	.dbline 275
	ldi R16,48
	ldi R17,117
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
	.dbline 276
	tst R10
	brne L76
	tst R11
	brne L76
X21:
	.dbline 276
	.dbline 277
	ldi R16,<L82
	ldi R17,>L82
	xcall _puts_M
	.dbline 278
	.dbline 279
	.dbline 274
	.dbline 274
	xjmp L76
X22:
	.dbline -2
L57:
	adiw R28,4
	.dbline 0 ; func end
	ret
	.dbsym r err_net 12 I
	.dbsym r err_con 10 I
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L82:
	.blkb 18
	.area idata
	.byte 'I,'t,39,'s,32,'s,'o,32,'b,'o,'r,'i,'n,'g,46,46
	.byte 46,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L75:
	.blkb 6
	.area idata
	.byte 'd,'i,'s,'c,'d,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L71:
	.blkb 20
	.area idata
	.byte 'L,'i,'s,'t,'e,'n,'i,'n,'g,32,'a,'t,32,37,'s,58
	.byte 37,'u,10,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L70:
	.blkb 18
	.area idata
	.byte 'E,'r,'r,'o,'r,58,32,'N,'o,32,'n,'e,'t,'w,'o,'r
	.byte 'k,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L65:
	.blkb 10
	.area idata
	.byte 'A,'T,'m,'e,'g,'a,49,50,56,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L64:
	.blkb 6
	.area idata
	.byte 32,'f,'o,'r,32,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L63:
	.blkb 7
	.area idata
	.byte 'I,'C,'C,'A,'V,'R,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L62:
	.blkb 13
	.area idata
	.byte 'C,'o,'m,'p,'i,'l,'e,'d,32,'b,'y,32,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L61:
	.blkb 11
	.area idata
	.byte 'N,'u,'t,47,'O,'S,32,37,'s,10,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L60:
	.blkb 32
	.area idata
	.byte 10,10,'D,'i,'s,'c,'o,'v,'e,'r,'y,32,'S,'e,'r,'v
	.byte 'i,'c,'e,32,'V,'e,'r,'s,'i,'o,'n,32,37,'s,10,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L22:
	.blkb 14
	.area idata
	.byte 50,53,53,46,50,53,53,46,50,53,53,46,48,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L21:
	.blkb 16
	.area idata
	.byte 49,57,50,46,49,54,56,46,49,57,50,46,50,48,50,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L16:
	.blkb 5
	.area idata
	.byte 'e,'t,'h,48,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L9:
	.blkb 2
	.area idata
	.byte 'w,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L8:
	.blkb 6
	.area idata
	.byte 'u,'a,'r,'t,48,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
L2:
	.blkb 6
	.area idata
	.byte 49,46,48,46,49,0
	.area data(ram, con, rel)
	.dbfile C:\ethernut\tecnotes\tn-discover\discover.c
	.area func_lit
PL_DiscoverServer:	.word `_DiscoverServer
